/**
 *
 * Build for package @reactivelib/core version v1.0.1
 *
 * Copyright 2017 Christoph Rodak (christoph@rodak.li)
 *
 *
 * For more information, visit https://github.com/reactivelib/core
 *
 */
 
(function(){
    /**
     * tslib specific functions.
    **/
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    var __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    var __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    var __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    var __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };
    
    (function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["core"] = factory();
	else
		root["reactivelib"] = root["reactivelib"] || {}, root["reactivelib"]["core"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 8);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
function compose() {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return function (result) {
        for (var i = fns.length - 1; i > -1; i--) {
            result = fns[i].call(this, result);
        }
        return result;
    };
}
exports.compose = compose;
;
function compose2(a, b) {
    if (!a) {
        return b;
    }
    return function (arg) {
        return a(b(arg));
    };
}
exports.compose2 = compose2;
function combine(f1, f2) {
    if (!f2) {
        return f1;
    }
    if (!f1) {
        return f2;
    }
    if (f1.length === 0) {
        return function () {
            f1();
            f2();
        };
    }
    if (f1.length === 1) {
        return function (p1) {
            f1(p1);
            f2(p1);
        };
    }
    if (f1.length === 2) {
        return function (p1, p2) {
            f1(p1, p2);
            f2(p1, p2);
        };
    }
    if (f1.length === 3) {
        return function (p1, p2, p3) {
            f1(p1, p2, p3);
            f2(p1, p2, p3);
        };
    }
    if (f1.length === 4) {
        return function (p1, p2, p3, p4) {
            f1(p1, p2, p3, p4);
            f2(p1, p2, p3, p4);
        };
    }
    if (f1.length === 5) {
        return function (p1, p2, p3, p4, p5) {
            f1(p1, p2, p3, p4, p5);
            f2(p1, p2, p3, p4, p5);
        };
    }
    throw new Error("Too many arguments");
}
exports.combine = combine;
function combineAllInObject(o1, o2) {
    var res = {};
    for (var p in o1) {
        res[p] = combine(o1[p], o2[p]);
    }
    return res;
}
exports.combineAllInObject = combineAllInObject;
function combineAllInObjects(o) {
    var res = o[0];
    for (var i = 1; i < o.length; i++) {
        res = combineAllInObject(res, o[i]);
    }
    return res;
}
exports.combineAllInObjects = combineAllInObjects;
function dummy() {
}
exports.dummy = dummy;


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Node of a list
 */
var Node = /** @class */ (function () {
    function Node(value, list) {
        this.value = value;
        this.list = list;
        this.removed = false;
        this.next = null;
        this.previous = null;
    }
    Node.prototype.remove = function () {
        if (!this.removed) {
            this.list.size--;
            this.next.previous = this.previous;
            this.previous.next = this.next;
            this.removed = true;
            return true;
        }
        return false;
    };
    Node.prototype.addBefore = function (data) {
        var node = this.list.createNode(data);
        node.next = this;
        node.previous = this.previous;
        node.removed = false;
        this.previous.next = node;
        this.previous = node;
        this.list.size++;
    };
    Node.prototype.addAfter = function (data) {
        var node = this.list.createNode(data);
        node.previous = this;
        node.next = this.next;
        node.removed = false;
        this.next.previous = node;
        this.next = node;
        this.list.size++;
    };
    return Node;
}());
/**
 * A double linked list
 * @param E the type of the list elements
 */
var List = /** @class */ (function () {
    function List() {
        this.size = 0;
        this.first = this.createNode(null);
        this.last = this.createNode(null);
        this.last.next = this.last;
        this.last.previous = this.first;
        this.first.next = this.last;
        this.first.previous = this.first;
    }
    List.prototype.createNode = function (value) {
        return new Node(value, this);
    };
    List.prototype.addLast = function (element) {
        var ln = this.createNode(element);
        this.addLastNode(ln);
        return ln;
    };
    List.prototype.addLastNode = function (node) {
        this.size++;
        node.next = this.last;
        node.previous = this.last.previous;
        node.removed = false;
        this.last.previous.next = node;
        this.last.previous = node;
    };
    List.prototype.addFirst = function (element) {
        var node = this.createNode(element);
        this.addFirstNode(node);
        return node;
    };
    List.prototype.addFirstNode = function (node) {
        this.size++;
        node.previous = this.first;
        node.next = this.first.next;
        node.removed = false;
        this.first.next.previous = node;
        this.first.next = node;
    };
    List.prototype.findAndRemove = function (element) {
        var ln = this.first;
        ln = ln.next;
        while (ln != this.last) {
            if (ln.value === element) {
                ln.remove();
                return true;
            }
            ln = ln.next;
        }
        return false;
    };
    List.prototype.contains = function (element) {
        var ln = this.first;
        ln = ln.next;
        while (ln != this.last) {
            if (ln.value === element) {
                return true;
            }
            ln = ln.next;
        }
        return false;
    };
    List.prototype.forEach = function (f) {
        var ln = this.first;
        ln = ln.next;
        while (ln != this.last) {
            f(ln.value);
            ln = ln.next;
        }
    };
    List.prototype.get = function (index) {
        var it = this.iterator();
        var i = 0;
        while (it.hasNext()) {
            var n = it.next();
            if (i === index) {
                return n;
            }
            i++;
        }
        return null;
    };
    List.prototype.iterator = function () {
        var ln = this.first;
        var last = this.last;
        ln = ln.next;
        return {
            hasNext: function () {
                return ln !== last;
            },
            next: function () {
                var next = ln;
                ln = ln.next;
                return next.value;
            }
        };
    };
    return List;
}());
/**
 * Creates a new list
 * @return the created list
 */
function list() {
    return new List();
}
exports.default = list;


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
function copyClass(clazz) {
    var B = /** @class */ (function (_super) {
        __extends(B, _super);
        function B() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return B;
    }(clazz));
    return B;
}
exports.copyClass = copyClass;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var EmptyOptional = /** @class */ (function () {
    function EmptyOptional() {
    }
    Object.defineProperty(EmptyOptional.prototype, "value", {
        get: function () {
            throw new Error("Optional is empty");
        },
        enumerable: true,
        configurable: true
    });
    return EmptyOptional;
}());
EmptyOptional.prototype.present = false;
var Optional = /** @class */ (function () {
    function Optional(value) {
        this.value = value;
    }
    return Optional;
}());
Optional.prototype.present = true;
function empty() {
    return new EmptyOptional();
}
function optional(val) {
    if (val === void 0) {
        return empty();
    }
    return new Optional(val);
}
exports.optional = optional;


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
if (typeof window === "undefined" || !window.requestAnimationFrame) {
    var lastTime = 0;
    requestAnimationVar = function (callback) {
        var currTime = new Date().getTime();
        var timeToCall = Math.max(0, 16 - (currTime - lastTime));
        var id = setTimeout(function () { callback(currTime + timeToCall); }, timeToCall);
        lastTime = currTime + timeToCall;
        return id;
    };
}
else {
    var requestAnimationVar = function (anim) {
        return window.requestAnimationFrame(anim);
    };
}
var cancelAnimationVar;
if (typeof window === "undefined" || !window.cancelAnimationFrame) {
    cancelAnimationVar = function (id) {
        clearTimeout(id);
    };
}
else {
    cancelAnimationVar = function (id) {
        window.cancelAnimationFrame(id);
    };
}
exports.requestAnimation = requestAnimationVar;
exports.cancelAnimation = cancelAnimationVar;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
function isEmptyObject(obj) {
    return Object.getOwnPropertyNames(obj).length === 0;
}
function removeEmptyProperties(config) {
    var empties = [];
    for (var p in config) {
        if (typeof config[p] !== "boolean" && !config[p]) {
            empties.push(p);
        }
        else if (typeof config[p] === "object") {
            if (isEmptyObject(config[p])) {
                empties.push(p);
            }
        }
    }
    for (var i = 0; i < empties.length; i++) {
        delete config[empties[i]];
    }
    return config;
}
exports.removeEmptyProperties = removeEmptyProperties;


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var Extender = /** @class */ (function () {
    function Extender() {
        this.deep = false;
        this.missing = false;
    }
    Extender.prototype.getProperties = function (arg) {
        var args = [];
        for (var p in arg) {
            args.push(p);
        }
        return args;
    };
    Extender.prototype.extend = function (args) {
        var first = args[0];
        for (var i = 1; i < args.length; i++) {
            var ex = args[i];
            if (ex) {
                var props = this.getProperties(ex);
                for (var j = 0; j < props.length; j++) {
                    var k = props[j];
                    if (typeof ex === "object" && ex.hasOwnProperty(k)) {
                        if (this.deep) {
                            var left = first[k];
                            var right = ex[k];
                            if (left && typeof left === 'object' && right && typeof right === 'object') {
                                this.extend([left, right]);
                            }
                            else {
                                if (!this.missing || !first.hasOwnProperty(k)) {
                                    Object.defineProperty(first, k, Object.getOwnPropertyDescriptor(ex, k));
                                }
                            }
                        }
                        else {
                            if (!this.missing || !first.hasOwnProperty(k)) {
                                Object.defineProperty(first, k, Object.getOwnPropertyDescriptor(ex, k));
                            }
                        }
                    }
                }
            }
        }
        return first;
    };
    return Extender;
}());
exports.Extender = Extender;
var stdExtender = new Extender();
var deepExtender = new Extender();
deepExtender.deep = true;
var missingExtender = new Extender();
missingExtender.missing = true;
/**
 *
 * @param any
 * @returns {any}
 */
function extend() {
    var any = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        any[_i] = arguments[_i];
    }
    return stdExtender.extend(any);
}
exports.extend = extend;
exports.default = extend;
/**
 *
 * Merges the given objects into the first object using a deep merge
 */
function deep() {
    var any = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        any[_i] = arguments[_i];
    }
    return deepExtender.extend(any);
}
exports.deep = deep;
/**
 * Merges the given objects into the first object using given properties
 */
function missing() {
    var any = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        any[_i] = arguments[_i];
    }
    return missingExtender.extend(any);
}
exports.missing = missing;
function properties(p) {
    var ext = new Extender();
    ext.getProperties = function () {
        return p;
    };
    return ext;
}
exports.properties = properties;
function configure(config) {
    var ext = new Extender();
    properties(["deep", "missing"]).extend(ext, config);
    if (config.properties) {
        ext.getProperties = function () {
            return config.properties;
        };
    }
    return ext;
}
exports.configure = configure;


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var hashIds = 0;
function hash(value) {
    if (value != null && typeof value == 'object') {
        if ("getHash" in value) {
            return value.getHash();
        }
        else if ("_hashId" in value) {
            return value._hashId;
        }
        else {
            hashIds++;
            set(value, hashIds);
            return hashIds + "";
        }
    }
    else {
        return value + "";
    }
}
exports.hash = hash;
exports.default = hash;
/**
 *
 * @param object
 * @param value
 */
function set(object, value) {
    object._hashId = value;
}
exports.set = set;
var s = set;
var HashMap = /** @class */ (function () {
    function HashMap() {
        this.objects = {};
    }
    HashMap.prototype.put = function (k, v) {
        this.objects[hash(k)] = { key: k, value: v };
    };
    HashMap.prototype.get = function (k) {
        var v = this.objects[hash(k)];
        if (!v) {
            return null;
        }
        return v.value;
    };
    HashMap.prototype.remove = function (k) {
        delete this.objects[hash(k)];
    };
    return HashMap;
}());
function map() {
    return new HashMap();
}
exports.map = map;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var hashMod = __importStar(__webpack_require__(7));
var funcMod = __importStar(__webpack_require__(0));
var extendMod = __importStar(__webpack_require__(6));
var objectMod = __importStar(__webpack_require__(5));
var timer_1 = __webpack_require__(4);
exports.cancelAnimation = timer_1.cancelAnimation;
exports.requestAnimation = timer_1.requestAnimation;
var optional_1 = __webpack_require__(3);
exports.optional = optional_1.optional;
var func_1 = __webpack_require__(0);
exports.dummy = func_1.dummy;
var mixin_1 = __webpack_require__(2);
exports.copyClass = mixin_1.copyClass;
var list_1 = __webpack_require__(1);
exports.list = list_1.default;
exports.func = funcMod;
/**
 *
 * @param args
 * @returns {any}
 */
function extend() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return extendMod.default.apply(null, args);
}
exports.extend = extend;
function hash(val) {
    return hashMod.default(val);
}
exports.hash = hash;
(function (hash) {
    hash.setHash = hashMod.set;
    hash.map = hashMod.map;
})(hash = exports.hash || (exports.hash = {}));
(function (extend) {
    extend.deep = extendMod.deep;
    extend.missing = extendMod.missing;
    extend.props = extendMod.properties;
})(extend = exports.extend || (exports.extend = {}));
exports.object = objectMod;


/***/ })
/******/ ]);
});
})();
