"use strict";
/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
function compose() {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return function (result) {
        for (var i = fns.length - 1; i > -1; i--) {
            result = fns[i].call(this, result);
        }
        return result;
    };
}
exports.compose = compose;
;
function compose2(a, b) {
    if (!a) {
        return b;
    }
    return function (arg) {
        return a(b(arg));
    };
}
exports.compose2 = compose2;
function combine(f1, f2) {
    if (!f2) {
        return f1;
    }
    if (!f1) {
        return f2;
    }
    if (f1.length === 0) {
        return function () {
            f1();
            f2();
        };
    }
    if (f1.length === 1) {
        return function (p1) {
            f1(p1);
            f2(p1);
        };
    }
    if (f1.length === 2) {
        return function (p1, p2) {
            f1(p1, p2);
            f2(p1, p2);
        };
    }
    if (f1.length === 3) {
        return function (p1, p2, p3) {
            f1(p1, p2, p3);
            f2(p1, p2, p3);
        };
    }
    if (f1.length === 4) {
        return function (p1, p2, p3, p4) {
            f1(p1, p2, p3, p4);
            f2(p1, p2, p3, p4);
        };
    }
    if (f1.length === 5) {
        return function (p1, p2, p3, p4, p5) {
            f1(p1, p2, p3, p4, p5);
            f2(p1, p2, p3, p4, p5);
        };
    }
    throw new Error("Too many arguments");
}
exports.combine = combine;
function combineAllInObject(o1, o2) {
    var res = {};
    for (var p in o1) {
        res[p] = combine(o1[p], o2[p]);
    }
    return res;
}
exports.combineAllInObject = combineAllInObject;
function combineAllInObjects(o) {
    var res = o[0];
    for (var i = 1; i < o.length; i++) {
        res = combineAllInObject(res, o[i]);
    }
    return res;
}
exports.combineAllInObjects = combineAllInObjects;
function dummy() {
}
exports.dummy = dummy;
