"use strict";
/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var hashIds = 0;
function hash(value) {
    if (value != null && typeof value == 'object') {
        if ("getHash" in value) {
            return value.getHash();
        }
        else if ("_hashId" in value) {
            return value._hashId;
        }
        else {
            hashIds++;
            set(value, hashIds);
            return hashIds + "";
        }
    }
    else {
        return value + "";
    }
}
exports.hash = hash;
exports.default = hash;
/**
 *
 * @param object
 * @param value
 */
function set(object, value) {
    object._hashId = value;
}
exports.set = set;
var s = set;
var HashMap = /** @class */ (function () {
    function HashMap() {
        this.objects = {};
    }
    HashMap.prototype.put = function (k, v) {
        this.objects[hash(k)] = { key: k, value: v };
    };
    HashMap.prototype.get = function (k) {
        var v = this.objects[hash(k)];
        if (!v) {
            return null;
        }
        return v.value;
    };
    HashMap.prototype.remove = function (k) {
        delete this.objects[hash(k)];
    };
    return HashMap;
}());
function map() {
    return new HashMap();
}
exports.map = map;
