"use strict";
/*
 * Copyright (c) 2018. Christoph Rodak  (https://reactivechart.com)
 */
Object.defineProperty(exports, "__esModule", { value: true });
if (typeof window === "undefined" || !window.requestAnimationFrame) {
    var lastTime = 0;
    requestAnimationVar = function (callback) {
        var currTime = new Date().getTime();
        var timeToCall = Math.max(0, 16 - (currTime - lastTime));
        var id = setTimeout(function () { callback(currTime + timeToCall); }, timeToCall);
        lastTime = currTime + timeToCall;
        return id;
    };
}
else {
    var requestAnimationVar = function (anim) {
        return window.requestAnimationFrame(anim);
    };
}
var cancelAnimationVar;
if (typeof window === "undefined" || !window.cancelAnimationFrame) {
    cancelAnimationVar = function (id) {
        clearTimeout(id);
    };
}
else {
    cancelAnimationVar = function (id) {
        window.cancelAnimationFrame(id);
    };
}
exports.requestAnimation = requestAnimationVar;
exports.cancelAnimation = cancelAnimationVar;
